<template>
  <div
    class="page page-sticky flex flex_column flex-between">
    <div
      class="page_header"
      ref="header">
      <div class="page_header-inner flex flex-center flex-middle">
        <div class="page_header-back">
          <Btn
            flat
            icon
            v-if="backable && controls"
            @click="$emit('back')">
            <i class="i-icon-arrow-left"></i>
          </Btn>
        </div>
        <div class="page_header-title flex flex-middle">{{title}} <slot name="titleAppend"></slot></div>
        <div class="page_header-close">
          <Btn
            flat
            icon
            v-if="closable && controls"
            @click="$emit('close')">
            <i class="i-icon-close"></i>
          </Btn>
        </div>
      </div>
      <slot name="subtitle"></slot>
    </div>
    <div
      class="page_body"
      :class="[gradient ? 'page_body-gradient': '', haveSubtitle ? 'page_body-subtitle' : '', container ? 'container-pure': '']">
      <slot></slot>
    </div>
    <div
      class="page_footer"
      ref="footer">
      <FooterBtns v-if="!hideFooter"></FooterBtns>
    </div>
  </div>
</template>

<script>
  import Btn from '~/components/UI/Btn';
  import FooterBtns from '~/components/common/footer/FooterBtns';
  import * as bodyScrollLock from 'body-scroll-lock';

  export default {
    name: "pageWrapper",
    props: {
      controls: {
        type: Boolean,
        default: true
      },
      gradient: {
        type: Boolean,
        default: false
      },
      backable: {
        type: Boolean,
        default: false
      },
      closable: {
        type: Boolean,
        default: true
      },
      title: {
        type: String,
        default: ''
      },
      hideFooter: {
        type: Boolean,
        default: false
      },
      defaultScroll: {
        type: Boolean,
        default: false
      },
      container: {
        type: Boolean,
        default: true
      }
    },
    components: {
      Btn,
      FooterBtns
    },
    computed: {
      haveSubtitle() {
        return this.$slots.subtitle;
      }
    },
    methods: {
      enableScroll() {
        bodyScrollLock.enableBodyScroll(this.$el);
      },
      disableScroll() {
        bodyScrollLock.disableBodyScroll(this.$el, {
          allowTouchMove: el => {
            try {
              while (el && el.getAttribute && el !== document.body) {
                if (el.getAttribute('body-scroll-lock-ignore') !== null) {
                  return true;
                }
                el = el.parentNode;
              }
            } catch (e) {

            }
          }
        });
      }
    },
    beforeDestroy() {
      this.enableScroll();
    },
    mounted() {
      !this.defaultScroll && this.disableScroll();
    }
  }
</script>
